# class Cairo::GLTextureSurface

### Public Class Methods

new(p1) click to toggle source

    static VALUE
    cr_gl_texture_surface_initialize (int argc, VALUE *argv, VALUE self)
    {
      cairo_surface_t *surface;
      cairo_device_t *device;
      unsigned int texture;
      int width, height;
      cairo_content_t content = CAIRO_CONTENT_COLOR_ALPHA;
      VALUE rb_device, rb_texture, rb_width, rb_height, rb_content;

      rb_scan_args (argc, argv, "41",
                    &rb_device, &rb_texture, &rb_width, &rb_height, &rb_content);

      device = RVAL2CRDEVICE (rb_device);
      texture = NUM2UINT (rb_texture);
      width = NUM2INT (rb_width);
      height = NUM2INT (rb_height);
      switch (TYPE (rb_content))
        {
        case T_NIL:
          break;
        case T_STRING:
        case T_SYMBOL:
        case T_FIXNUM:
          content = RVAL2CRCONTENT (rb_content);
          break;
        default:
          rb_raise (rb_eArgError,
                    "invalid argument (expect "
                    "(device, texture, width, height) or "
                    "(device, texture, width, height, content)): %s",
                    rb_cairo__inspect (rb_ary_new4 (argc, argv)));
          break;
        }

      surface = cairo_gl_surface_create_for_texture (device, content,
                                                     texture,
                                                     width,
                                                     height);

      rb_cairo_surface_check_status (surface);
      DATA_PTR (self) = surface;
      if (rb_block_given_p ())
        rb_cairo__surface_yield_and_finish (self);
      return Qnil;
    }